#ifndef _PARSE_H_
#define _PARSE_H_

#ifdef _PARSE_C_
#define E
#else
#define E extern
#endif

#include "token.h"

#define EJ(e,j) j

/* constants */
#define PRES_ERROR	0
#define PRES_OK		1
#define PRES_END	2
#define PRES_INCLUDE	3
#define PRES_MACRO	4
#define PRES_ENDM	5
#define PRES_MACRONEST	6
#define PRES_BINCLUDE	7

#define MACRO_ARG_CHAR '%'

/* if-else-endif handling */
#define IFSTT_NONE		0	/* normal mode */
#define IFSTT_SKIP_UNTIL_ELSE	1	/* after 'IF <false>': skip until {ELSE|ENDIF} */
#define IFSTT_JUST_IGNORE_ENDIF	2	/* after 'IF <false> ... ELSE': if ENDIF is found, just ignore it */
#define IFSTT_SEARCH_ELSE	3	/* after 'IF <true>' : if ELSE is found, skip until ENDIF */
#define IFSTT_SKIP_UNTIL_ENDIF	4	/* after 'IF <true> ... ELSE' : skip until ENDIF */
#define IFSTT_SKIP_ALL		5	/* IF-ELSE-ENDIF inside IF <false> ... ENDIF */

#define MAX_IFSTK	10

/* parse info */
typedef struct {
	int		linenum;
	unsigned long	filename;	/* id of string */
	unsigned long	srclinebuf;	/* id of source line buf */
	int		ifstt;
	int		ifsp;
	int		ifstk[MAX_IFSTK];
	int		rept_cnt;
	char		buf[256];
	unsigned long	macroargs[9];
	FILE		*srcfile;
	FILE		*pass2;
} parseinfo;

/* functions */
E int parse(char *, parseinfo *);
E int parse_endm(char *, parseinfo *);
E int start_asm(void);
E int finish_asm(void);
E int quit_asm(void);
E unsigned char *getbininfo(int *, int *, int *);
E int putbin(unsigned char);
E int fix_in_page_address(void);

#undef E

#endif /*_PARSE_H_*/
